# lusid-web-app-sdk
FINBOURNE Technology

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.4.1356
- Package version: 0.4.1356
- Build package: org.openapitools.codegen.languages.PythonLegacyClientCodegen
For more information, please visit [https://www.finbourne.com](https://www.finbourne.com)

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import lusid_web_app
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import lusid_web_app
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function

import time
import lusid_web_app
from lusid_web_app.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://fbn-ci.lusid.com/app
# See configuration.py for a list of all supported configuration parameters.
configuration = lusid_web_app.Configuration(
    host = "https://fbn-ci.lusid.com/app"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure OAuth2 access token for authorization: oauth2
configuration = lusid_web_app.Configuration(
    host = "https://fbn-ci.lusid.com/app"
)
configuration.access_token = 'YOUR_ACCESS_TOKEN'


# Enter a context with an instance of the API client
with lusid_web_app.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = lusid_web_app.AccessApi(api_client)
    
    try:
        # Get a list of things that the user has access to.  This includes Features and resources.
        api_response = api_instance.api_access_get()
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling AccessApi->api_access_get: %s\n" % e)
    
```

## Documentation for API Endpoints

All URIs are relative to *https://fbn-ci.lusid.com/app*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AccessApi* | [**api_access_get**](docs/AccessApi.md#api_access_get) | **GET** /api/access | Get a list of things that the user has access to.  This includes Features and resources.
*ArticlesApi* | [**api_articles_get**](docs/ArticlesApi.md#api_articles_get) | **GET** /api/articles | 
*AuditingApi* | [**auditing_create_entry**](docs/AuditingApi.md#auditing_create_entry) | **POST** /api/auditing/entries | Auditing.CreateEntry: Create (persist) and audit entry..
*AuditingApi* | [**auditing_get_entries**](docs/AuditingApi.md#auditing_get_entries) | **GET** /api/auditing/entries | Auditing.GetEntries: Get the audit entries.
*AuditingApi* | [**auditing_get_processes**](docs/AuditingApi.md#auditing_get_processes) | **GET** /api/auditing/processes | Auditing.GetProcesses: Get the latest audit entry for each process.
*AuditingApi* | [**auditing_list_entries**](docs/AuditingApi.md#auditing_list_entries) | **GET** /api/auditing/entries2 | Auditing.ListEntries: Get the audit entries.
*ConfigApi* | [**get_app_config**](docs/ConfigApi.md#get_app_config) | **GET** /api/Config/app | GetAppConfig: 
*ConfigApi* | [**get_version**](docs/ConfigApi.md#get_version) | **GET** /api/Config/app/version | GetVersion: 
*ContactsApi* | [**api_contacts_me_get**](docs/ContactsApi.md#api_contacts_me_get) | **GET** /api/contacts/me | Get contact information for the current user.
*ContactsApi* | [**api_contacts_me_put**](docs/ContactsApi.md#api_contacts_me_put) | **PUT** /api/contacts/me | Updates some information about the current user.
*ContactsApi* | [**api_contacts_post**](docs/ContactsApi.md#api_contacts_post) | **POST** /api/contacts | Create a contact for the currrent user (if one does not already exists)
*ContactsApi* | [**api_domains_post**](docs/ContactsApi.md#api_domains_post) | **POST** /api/domains | Create a new account: domain, lead and contact (if a contact with the requested email does not already exist)
*LoggingApi* | [**logging_create_log_message**](docs/LoggingApi.md#logging_create_log_message) | **POST** /api/logging | Logging.CreateLogMessage: Log the supplied message with the specified logLevel.
*PersonalisationsApi* | [**personalisations_delete_personalisation**](docs/PersonalisationsApi.md#personalisations_delete_personalisation) | **DELETE** /api/Personalisations | Personalisations.DeletePersonalisation: Delete a personalisation
*PersonalisationsApi* | [**personalisations_get_personalisations**](docs/PersonalisationsApi.md#personalisations_get_personalisations) | **GET** /api/Personalisations | Personalisations.GetPersonalisations: Get personalisation
*PersonalisationsApi* | [**personalisations_upsert_personalisations**](docs/PersonalisationsApi.md#personalisations_upsert_personalisations) | **POST** /api/Personalisations | Personalisations.UpsertPersonalisations: Create or replace personalisations
*ReconciliationsApi* | [**delete_reconciliation_mapping**](docs/ReconciliationsApi.md#delete_reconciliation_mapping) | **DELETE** /api/reconciliations/mapping/{scope}/{code} | DeleteReconciliationMapping: Delete a mapping
*ReconciliationsApi* | [**get_reconciliation_mapping**](docs/ReconciliationsApi.md#get_reconciliation_mapping) | **GET** /api/reconciliations/mapping/{scope}/{code} | GetReconciliationMapping: Get a mapping
*ReconciliationsApi* | [**list_reconciliation_mappings**](docs/ReconciliationsApi.md#list_reconciliation_mappings) | **GET** /api/reconciliations/mapping | ListReconciliationMappings: List the reconciliation mappings
*ReconciliationsApi* | [**reconcile_transactions**](docs/ReconciliationsApi.md#reconcile_transactions) | **POST** /api/reconciliations/transactions | ReconcileTransactions: Perform a Transactions Reconcilliation.
*ReconciliationsApi* | [**upsert_reconciliation_mapping**](docs/ReconciliationsApi.md#upsert_reconciliation_mapping) | **POST** /api/reconciliations/mapping | UpsertReconciliationMapping: Create or update a mapping
*ReportsApi* | [**delete_lusid_token**](docs/ReportsApi.md#delete_lusid_token) | **DELETE** /api/Reports/lusid/token | DeleteLusidToken: Update the reporting infrastructure to remove references to the user&#39;s LUSID session
*ReportsApi* | [**get_log_on_token**](docs/ReportsApi.md#get_log_on_token) | **GET** /api/Reports/logon/token | GetLogOnToken: Get a log-on token for use with reporting.
*ReportsApi* | [**update_lusid_session**](docs/ReportsApi.md#update_lusid_session) | **POST** /api/Reports/lusid/token | UpdateLusidSession: Update the reporting infrastructure to reflect changes in the user&#39;s LUSID session
*RoadmapApi* | [**roadmap_get_roadmap**](docs/RoadmapApi.md#roadmap_get_roadmap) | **GET** /api/Roadmap | Roadmap.GetRoadmap: Get the list of currently released of future roadmap entries
*RoadmapApi* | [**roadmap_get_roadmap_history**](docs/RoadmapApi.md#roadmap_get_roadmap_history) | **GET** /api/Roadmap/history | Roadmap.GetRoadmapHistory: Get the list of released roadmap entries
*SettingsApi* | [**settings_create_or_update**](docs/SettingsApi.md#settings_create_or_update) | **PUT** /api/Settings/{key}/{name} | Settings.CreateOrUpdate: Create or update a setting.
*SettingsApi* | [**settings_delete_by_key**](docs/SettingsApi.md#settings_delete_by_key) | **DELETE** /api/Settings/{key} | Settings.DeleteByKey: Delete all of the settings in the specified area.
*SettingsApi* | [**settings_delete_by_key_name**](docs/SettingsApi.md#settings_delete_by_key_name) | **DELETE** /api/Settings/{key}/{name} | Settings.DeleteByKeyName: Delete the setting with the specified key/name pair.
*SettingsApi* | [**settings_get_by_key**](docs/SettingsApi.md#settings_get_by_key) | **GET** /api/Settings/{key} | Settings.GetByKey: Get the settings for the specified area.
*SettingsApi* | [**settings_get_by_key_name**](docs/SettingsApi.md#settings_get_by_key_name) | **GET** /api/Settings/{key}/{name} | Settings.GetByKeyName: Get the setting for this key/name pair.
*SettingsApi* | [**settings_get_keys**](docs/SettingsApi.md#settings_get_keys) | **GET** /api/Settings | Settings.GetKeys: Get the keys (areas) available to the caller.
*SettingsApi* | [**settings_save**](docs/SettingsApi.md#settings_save) | **POST** /api/Settings | Settings.Save: Create a setting.
*TicketsApi* | [**tickets_close_ticket**](docs/TicketsApi.md#tickets_close_ticket) | **PUT** /api/tickets/{ticketId} | Tickets.CloseTicket: 
*TicketsApi* | [**tickets_create_ticket**](docs/TicketsApi.md#tickets_create_ticket) | **POST** /api/tickets | Tickets.CreateTicket: Create a new ticket.
*TicketsApi* | [**tickets_get_tickets**](docs/TicketsApi.md#tickets_get_tickets) | **GET** /api/tickets | Tickets.GetTickets: 
*TicketsApi* | [**tickets_update_ticket**](docs/TicketsApi.md#tickets_update_ticket) | **PUT** /api/tickets | Tickets.UpdateTicket: 


## Documentation For Models

 - [AuditData](docs/AuditData.md)
 - [AuditDataSummary](docs/AuditDataSummary.md)
 - [AuditEntry](docs/AuditEntry.md)
 - [AuditEntryNote](docs/AuditEntryNote.md)
 - [AuditProcess](docs/AuditProcess.md)
 - [AuditProcessSummary](docs/AuditProcessSummary.md)
 - [ClientConfig](docs/ClientConfig.md)
 - [Contact](docs/Contact.md)
 - [ContactPropertiesRequest](docs/ContactPropertiesRequest.md)
 - [CreateAuditEntryRequest](docs/CreateAuditEntryRequest.md)
 - [CreateDomainRequest](docs/CreateDomainRequest.md)
 - [CurrencyAndAmount](docs/CurrencyAndAmount.md)
 - [HubspotContact](docs/HubspotContact.md)
 - [HubspotIdentity](docs/HubspotIdentity.md)
 - [HubspotIdentityProfile](docs/HubspotIdentityProfile.md)
 - [HubspotResponseProperty](docs/HubspotResponseProperty.md)
 - [HubspotResponsePropertyVersion](docs/HubspotResponsePropertyVersion.md)
 - [HubspotSupportArticle](docs/HubspotSupportArticle.md)
 - [HubspotSupportArticleList](docs/HubspotSupportArticleList.md)
 - [LabelValueSet](docs/LabelValueSet.md)
 - [Link](docs/Link.md)
 - [LogLevel](docs/LogLevel.md)
 - [LusidProblemDetails](docs/LusidProblemDetails.md)
 - [LusidValidationProblemDetails](docs/LusidValidationProblemDetails.md)
 - [Mapping](docs/Mapping.md)
 - [MappingComparisonType](docs/MappingComparisonType.md)
 - [MappingRule](docs/MappingRule.md)
 - [MetricValue](docs/MetricValue.md)
 - [Mixpanel](docs/Mixpanel.md)
 - [OktaConfig](docs/OktaConfig.md)
 - [PerpetualProperty](docs/PerpetualProperty.md)
 - [Personalisation](docs/Personalisation.md)
 - [PersonalisationScope](docs/PersonalisationScope.md)
 - [ProblemDetails](docs/ProblemDetails.md)
 - [PropertyValue](docs/PropertyValue.md)
 - [ReCaptcha](docs/ReCaptcha.md)
 - [ReconciledTransactions](docs/ReconciledTransactions.md)
 - [Resource](docs/Resource.md)
 - [ResourceId](docs/ResourceId.md)
 - [ResourceListOfPersonalisation](docs/ResourceListOfPersonalisation.md)
 - [ResourceListOfRoadmapItem](docs/ResourceListOfRoadmapItem.md)
 - [RoadmapItem](docs/RoadmapItem.md)
 - [RoadmapItemCategory](docs/RoadmapItemCategory.md)
 - [ScrollableCollectionOfAuditEntry](docs/ScrollableCollectionOfAuditEntry.md)
 - [Setting](docs/Setting.md)
 - [TaskizeConfig](docs/TaskizeConfig.md)
 - [Ticket](docs/Ticket.md)
 - [TicketBase](docs/TicketBase.md)
 - [TicketsResponse](docs/TicketsResponse.md)
 - [Transaction](docs/Transaction.md)
 - [TransactionPrice](docs/TransactionPrice.md)
 - [TransactionPriceType](docs/TransactionPriceType.md)
 - [TransactionsReconciliationsRequest](docs/TransactionsReconciliationsRequest.md)
 - [TransactionsReconciliationsResponse](docs/TransactionsReconciliationsResponse.md)


## Documentation For Authorization


## oauth2

- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: https://lusid-fbn-prd.okta.com/oauth2/aus4d4lwsqZ7hWGU12p7/v1/authorize
- **Scopes**: N/A


## Author

info@finbourne.com


